# Uses of Class
org.apache.lucene.facet.taxonomy.FacetLabel

Packages that use FacetLabel
Package
Description
org.apache.lucene.facet.taxonomy
Taxonomy of Categories.
org.apache.lucene.facet.taxonomy.directory
Taxonomy index implementation using on top of a Directory.
org.apache.lucene.facet.taxonomy.writercache
Improves indexing time by caching a map of CategoryPath to their Ordinal.

- ## Uses of FacetLabel in org.apache.lucene.facet.taxonomy

  Methods in org.apache.lucene.facet.taxonomy that return FacetLabel
  Modifier and Type
  Method
  Description
  `FacetLabel[]`
  TaxonomyReader.`getBulkPath(int... ordinals)`
  Returns the path names of the list of ordinals associated with different categories.
  `abstract FacetLabel`
  TaxonomyReader.`getPath(int ordinal)`
  Returns the path name of the category with the given ordinal.
  `FacetLabel`
  TaxonomyFacetLabels.FacetLabelReader.`nextFacetLabel(int docId)`
  Retrieves the next `FacetLabel` for the specified `docId`, or `null` if there are no more.
  `FacetLabel`
  TaxonomyFacetLabels.FacetLabelReader.`nextFacetLabel(int docId, String facetDimension)`
  Retrieves the next `FacetLabel` for the specified `docId` under the requested `facetDimension`, or `null` if there are no more.
  `FacetLabel`
  FacetLabel.`subpath(int length)`
  Returns a sub-path of this path up to `length` components.
  Methods in org.apache.lucene.facet.taxonomy with parameters of type FacetLabel
  Modifier and Type
  Method
  Description
  `int`
  TaxonomyWriter.`addCategory(FacetLabel categoryPath)`
  addCategory() adds a category with a given path name to the taxonomy, and returns its ordinal.
  `int`
  FacetLabel.`compareTo(FacetLabel other)`
  Compares this path with another `FacetLabel` for lexicographic order.
  `int[]`
  TaxonomyReader.`getBulkOrdinals(FacetLabel... categoryPath)`
  Returns the ordinals of the categories given as a path.
  `abstract int`
  TaxonomyReader.`getOrdinal(FacetLabel categoryPath)`
  Returns the ordinal of the category given as a path.

- ## Uses of FacetLabel in org.apache.lucene.facet.taxonomy.directory

  Methods in org.apache.lucene.facet.taxonomy.directory that return FacetLabel
  Modifier and Type
  Method
  Description
  `FacetLabel[]`
  DirectoryTaxonomyReader.`getBulkPath(int... ordinals)`
  Returns an array of FacetLabels for a given array of ordinals.
  `FacetLabel`
  DirectoryTaxonomyReader.`getPath(int ordinal)`
  Methods in org.apache.lucene.facet.taxonomy.directory with parameters of type FacetLabel
  Modifier and Type
  Method
  Description
  `int`
  DirectoryTaxonomyWriter.`addCategory(FacetLabel categoryPath)`
  `protected void`
  DirectoryTaxonomyWriter.`enrichOrdinalDocument(Document d, FacetLabel categoryPath)`
  Child classes can implement this method to modify the document corresponding to a category path before indexing it.
  `protected void`
  ReindexingEnrichedDirectoryTaxonomyWriter.`enrichOrdinalDocument(Document d, FacetLabel categoryPath)`
  Add fields specified by the `ReindexingEnrichedDirectoryTaxonomyWriter.ordinalDataAppender` to the provided `Document`.
  `protected int`
  DirectoryTaxonomyWriter.`findCategory(FacetLabel categoryPath)`
  Look up the given category in the cache and/or the on-disk storage, returning the category's ordinal, or a negative number in case the category does not yet exist in the taxonomy.
  `int[]`
  DirectoryTaxonomyReader.`getBulkOrdinals(FacetLabel... categoryPaths)`
  `int`
  DirectoryTaxonomyReader.`getOrdinal(FacetLabel cp)`
  Method parameters in org.apache.lucene.facet.taxonomy.directory with type arguments of type FacetLabel
  Modifier and Type
  Method
  Description
  `void`
  ReindexingEnrichedDirectoryTaxonomyWriter.`reindexWithNewOrdinalData(BiConsumer<FacetLabel,Document> ordinalDataAppender)`
  Delete the existing taxonomy index and recreate it using new ordinal data.
  Constructor parameters in org.apache.lucene.facet.taxonomy.directory with type arguments of type FacetLabel
  Modifier
  Constructor
  Description
  ``
  `ReindexingEnrichedDirectoryTaxonomyWriter(Directory d, BiConsumer<FacetLabel,Document> ordinalDataAppender)`
  Create a taxonomy writer that will allow editing the ordinal docs before indexing them.

- ## Uses of FacetLabel in org.apache.lucene.facet.taxonomy.writercache

  Methods in org.apache.lucene.facet.taxonomy.writercache with parameters of type FacetLabel
  Modifier and Type
  Method
  Description
  `abstract void`
  LabelToOrdinal.`addLabel(FacetLabel label, int ordinal)`
  Adds a new label if it is not yet in the table.
  `int`
  LruTaxonomyWriterCache.`get(FacetLabel categoryPath)`
  `int`
  TaxonomyWriterCache.`get(FacetLabel categoryPath)`
  Lookup a category in the cache, returning its ordinal, or a negative number if the category is not in the cache.
  `abstract int`
  LabelToOrdinal.`getOrdinal(FacetLabel label)`
  Returns the ordinal assigned to the given label, or `LabelToOrdinal.INVALID_ORDINAL` if the label cannot be found in this table.
  `boolean`
  LruTaxonomyWriterCache.`put(FacetLabel categoryPath, int ordinal)`
  `boolean`
  TaxonomyWriterCache.`put(FacetLabel categoryPath, int ordinal)`
  Add a category to the cache, with the given ordinal as the value.